<?php

/**
 * resolucion actions.
 *
 * @package    controlComisiones
 * @subpackage resolucion
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class resolucionActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'COM_RESOLUCION',
        'COM_COMISION',
        'PROYECTOS',
        'TIPOS_COMISION'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'COM_COMISION' =>
        array(
            'id_comision' => 'COM_RESOLUCION'
        ),
        'PROYECTOS' =>
        array(
            'id_proyecto-id' => 'COM_COMISION'
        ),
        'TIPOS_COMISION' =>
        array(
            'id_tipo_comision' => 'COM_COMISION'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'COM_RESOLUCION' =>
        array(
            'id_resolucion' => 'id_resolucion',
            'id_comision' => 'id_comision',
            'no_resolucion' => 'no_resolucion',
            'fecha_resolucion' => 'fecha_resolucion',
            'id_anhos' => 'id_anhos',
            'estado' => 'estado',
            'fecha_anulacion' => 'fecha_anulacion',
            'motivo_anulacion' => 'motivo_anulacion',
        ),
        'COM_COMISION' =>
        array(
            'no_comision' => 'no_comision',
            'fecha_solicitud' => 'fecha_solicitud',
            'objeto' => 'objeto',
            'agenda' => 'agenda',
            'fecha_inicio' => 'fecha_inicio_comi',
            'fecha_fin' => 'fecha_fin_comi',
        ),
        'PROYECTOS' =>
        array(
            'descripcion' => 'descripcion_cm',
            'codigo' => 'codigo_cm'
        ),
        'TIPOS_COMISION' =>
        array(
            'descripcion' => 'descripcion'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'id_anhos', 'codigo_cm', 'no_resolucion', 'estado'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'COM_RESOLUCION' =>
        array(
            'id_resolucion,a' => array('!=' => array(-1)),
            'id_resolucion,b' => array('=' => array('id_resolucion')),
            'id_comision' => array('=' => array('id_comision')),
            'no_resolucion' => array('=' => array('no_resolucion')),
            'fecha_resolucion' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'estado' => array('=' => array('estado')),
            'id_anhos' => array('=' => array('id_anhos')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'COM_COMISION' =>
        array(
            'id_proyecto' => array('=' => array('id_proyecto')),
            'no_comision' => array('=' => array('no_comision'))
        ),
        'PROYECTOS' =>
        array(
            'id' => array('=' => array('id_proyecto')),
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_resolucion'; //identificador de la tabla
    protected $id_names = array('id_resolucion'); //llave primaria
    protected $field_names = array('id_comision', 'no_resolucion', 'fecha_resolucion', 'estado', 'id_anhos', 'fecha_anulacion', 'motivo_anulacion'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'COM_RESOLUCION'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_resolucion'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        //$logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $sql = <<<EOD
select to_char(sysdate,'YYYY') as ID_ANHOS FROM DUAL
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $id_anhos = $records[0]['id_anhos'];

            $request['id_anhos'] = $id_anhos;



            $request['estado'] = 1;


            CN_TABLE::executeSQL($sql);
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        $id_comision = $request['id_comision'];
        $sql = <<<EOD
select to_char(sysdate,'YYYY') as ID_ANHOS FROM DUAL
EOD;

        $records = CN_TABLE::executeSQL($sql);

        $id_anhos = $records[0]['id_anhos'];



        $sql = <<<EOD
select * from com_comision where id_comision = $id_comision
EOD;

        $records = CN_TABLE::executeSQL($sql);

        $id_proyecto = $records[0]['id_proyecto'];


        $sql = <<<EOD
select * from proyectos where id = $id_proyecto
EOD;

        $records = CN_TABLE::executeSQL($sql);
        //Se toma el año del proyecto - 20160210
        $id_anhos_com = $records[0]['ano_fiscal'];


        $sql = <<<EOD
select sum(valor) valor from com_comisionado_obj where id_comision = $id_comision group by id_obj_gasto
EOD;

        $records = CN_TABLE::executeSQL($sql);

        foreach ($records as $valores) {

            $valor = $valores['valor'];



            $sql = <<<EOD
select id_proyecto,sum(saldo) saldo from com_saldo_presup where id_proyecto = $id_proyecto and id_anhos='$id_anhos_com' group by id_proyecto
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $saldo = $records[0]['saldo'];

            //VALIDAR QUE HAYA SALDO A NIVEL DE CAJA MENOR Y OBJETO DE GASTO

            if ($saldo < $valor) {

                $errors['mensaje'] = "El valor de la comisión supera el saldo de la Caja Menor";
                $errors['servicio'] = "resolucion";
            }

            //VALIDAR QUE NO SE HAYA REGISTRADO YA UNA RESOLUCION PARA LA COMISION


            $sql = <<<EOD
select count(id_resolucion) cantidad from com_resolucion where id_comision = $id_comision and id_anhos='$id_anhos' and estado = 1
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $cantidad = $records[0]['cantidad'];

            if ($cantidad > 0) {

                $errors['mensaje'] = "Ya existe una resolución para esta comisión";
                $errors['servicio'] = "resolucion";
            }
        }




        /*
         *  Validar la operación, ya sea por SQL
         */


        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;


        $id_resolucion = $request['id_resolucion'];
        $anular = $request['anular'];

        if ($anular == true || $anular == "true" || $anular == 1 || $anular == "1") {

            $sql = <<<EOD
select count(id_cuenta) cantidad from com_cuenta where id_resolucion = $id_resolucion and estado = 1
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $cantidad = $records[0]['cantidad'];

            if ($cantidad > 0) {

                $errors['mensaje'] = "Existen cuentas asociadas a esta Resolución, no se puede anular.";
                $errors['servicio'] = "resolucion";
            }

            /*
             *  Validar la operación, ya sea por SQL
             */

            /*
             *  Generar errores en $errors
             */
        }

        return $errors;
    }

}
